#include "Matrix.h"
#include <iostream>

Matrix::Matrix(int z, int sp) {
   arr = new BasisTyp [z*sp];
   spanz=sp;
   zanz=z;
   }


Matrix::Matrix(const Matrix& m2) {
   spanz=m2.spanz;
   zanz=m2.zanz;
   arr = new BasisTyp[spanz*zanz];
   for (int i=0; i<spanz*zanz; ++i) {
      this->arr[i]  = m2.arr[i];
   }
}

Matrix& Matrix::operator=(const Matrix& m2) {
   if (this != &m2)
   {
      spanz = m2.spanz;
      zanz = m2.zanz;
      BasisTyp* tmp = new BasisTyp[spanz*zanz];
      for (int i = 0; i < spanz*zanz; ++i) {
         tmp[i] = m2.arr[i];
      }
      delete[] arr;
      arr = tmp;
   }
   return *this;
}

Matrix::~Matrix() {
   delete[] arr;
   arr = NULL;
   spanz=0;
   zanz=0;
   }

void Matrix::Resize(int z, int sp) {
   delete[] arr;
   arr = new BasisTyp [z*sp];
   spanz=sp;
   zanz=z;
   }

void Matrix::Setze(int z, int sp, BasisTyp wert) {
   int index = GetPos(z, sp);
   this->arr[index] = wert;
   }

BasisTyp Matrix::Lese(int z, int sp) const {
   int index = GetPos(z, sp);
   return this->arr[index];
   }

/** Aus dem zweidimensionalen Index wird der eindimensionale
Index berechnet.
*/
int Matrix::GetPos(const int z, int sp) const {
   int index = z * this->spanz + sp;
   if ((z >= 0) && (z < this->zanz) &&
      (sp >= 0) && (sp < this->spanz)) {
      if (index >= 0 && index < this->spanz*this->zanz) {
         return index;
      }
      else {
         std::cout << "Falscher Index berechnet" << z
            << " , sp=" << sp << ",Index=" << index << "\n";
         return 0;
      }
   }
   else {
      std::cout << "Falscher Index z=" << z
         << " , sp=" << sp << "\n";
      return 0;
   }
}



void Add(const Matrix& m1, const Matrix& m2, Matrix& m3){
   for (int i=0; i < m1.GetZeAnz(); ++i) {
      for (int j=0; j<m1.GetSpAnz(); ++j) {
         m3.Setze(i, j, m1.Lese(i,j) + m2.Lese(i,j));
         }// for j
      } // for i
   }


